#include "fft.h"

#include <math.h>
#define PI 3.1415926535

#define RANGE 1024

int sinTbl[FFT_SIZE/2];
int cosTbl[FFT_SIZE/2];

void SinCosTblInit()
{
	for ( int i=0; i<FFT_SIZE/2; i++) {
		sinTbl[i] = (int)(sin(-PI*i/(FFT_SIZE/2))*RANGE);
		cosTbl[i] = (int)(cos(-PI*i/(FFT_SIZE/2))*RANGE);
	}
}

void fft(short* idlr,COMPLEX* odl,COMPLEX* odr)
{
	int i,j;
	for(i=j=0;i<FFT_SIZE;i++){
		odl[i].real=idlr[j]/32;
		odl[i].imag=0;
		j++;
		odr[i].real=idlr[j]/32;
		odr[i].imag=0;
		j++;
	}
	fft(odl);
	fft(odr);
}

void fft(COMPLEX* od)
{
	COMPLEX str;
	// double th;
	int th;
	int i,is,j,k,m,max;

	for(i=j=0;i<FFT_SIZE;i++){
		if(i<j){            /* swap od[i],od[j] */
			str.real=od[j].real; od[j].real=od[i].real; od[i].real=str.real;
			str.imag=od[j].imag; od[j].imag=od[i].imag; od[i].imag=str.imag;
		}
		m=FFT_SIZE/2;
		while(j+1>m){
			j-=m;
			m/=2;
			if(m<2)break;
		}
		j+=m;
	}
	max=1;
	while(max<FFT_SIZE){
		is=max*2;
		for(k=0;k<max;k++){
			// th=-PI*k/max;
			th = FFT_SIZE/2*k/max;
			for(i=k;i<FFT_SIZE;i+=is){
				j=i+max;
				/* str = od[j] * exp(th) */
				str.real= od[j].real*cosTbl[th]/RANGE - od[j].imag*sinTbl[th] /RANGE;
				str.imag= od[j].real*sinTbl[th]/RANGE + od[j].imag*cosTbl[th] /RANGE;

				od[j].real=od[i].real-str.real;
				od[j].imag=od[i].imag-str.imag;
				od[i].real=od[i].real+str.real;
				od[i].imag=od[i].imag+str.imag;
			}
		}
		max=is;
	}
	for(i=0;i<FFT_SIZE;i++){
		od[i].real/=FFT_SIZE;
		od[i].imag/=FFT_SIZE;
	}
}
